import math
import random

def angleCompare( thd1, thd2, window ):
    # make sure the angles are between 0.0 and 360.0
    while thd1 > 360.0: thd1 -= 360.0
    while thd2 > 360.0: thd2 -= 360.0
    while thd1 <   0.0: thd1 += 360.0
    while thd2 <   0.0: thd2 += 360.0
    # figure out their relative positions on the unit circle
    smaller = min(thd1,thd2)
    larger  = max(thd1,thd2)
    # figure out the two possible differences
    oneway = larger - smaller
    otherway = (360.0-larger) + smaller
    # is the difference within the window?
    return min(oneway,otherway) <= window

def computeSmallestAngleDifference( fromThr, toThr ):
    # make sure the angles are between 0.0 and 360.0
    twopi = 2*math.pi
    while fromThr > twopi: fromThr -= twopi
    while toThr > twopi: toThr -= twopi
    while fromThr <  0.0: fromThr += twopi
    while toThr <  0.0: toThr += twopi
    # figure out their relative positions on the unit circle
    smaller = min(fromThr, toThr)
    larger  = max(fromThr, toThr)
    # figure out the two possible differences
    oneway = larger - smaller
    otherway = (twopi-larger) + smaller
    # here is the diference
    return min(oneway,otherway)

def computeSmallestSignedAngleDifference( fromThr, toThr ):
    posDiffr = computeSmallestAngleDifference( fromThr, toThr )
    # but we need to sign this to go from fromThr to toThr
    add = computeSmallestAngleDifference( fromThr + posDiffr, toThr )
    sub = computeSmallestAngleDifference( fromThr - posDiffr, toThr )
    if add < sub:
        return posDiffr
    else:
        return -posDiffr

def dist( x1, y1, x2, y2 ):
    return math.sqrt( (x1-x2)**2 + (y1-y2)**2 )

def computeTotalRobotMotion( oldLoc, newLoc ):
    # this is wrong! It handles going backwards by
    # turning 180 and then turning back! - not good!
    oldx, oldy, oldthr = oldLoc
    x, y, thr = newLoc
    print 'oldLoc, newLoc are', oldLoc, newLoc
    # we return thr1, dist, thr2
    # where
    # thr1 is the smallest angle in radians from oldThr
    #         to the direction of the vector (x,y)-(oldx,oldy)
    # dist is the distance between (x,y) and (oldx, oldy)
    # thr2 is the smallest angle in radians from the direction
    #         of the vector mentioned above to thr
    motion_thr = math.atan2(y-oldy, x-oldx)
    thr1 = computeSmallestSignedAngleDifference( oldthr, motion_thr )
    dist = math.sqrt( (x-oldx)**2 + (y-oldy)**2 )
    thr2 = computeSmallestSignedAngleDifference( motion_thr, thr )
    print 'thr1, dist, thr2 are', math.degrees(thr1), dist, math.degrees(thr2)
    return (thr1, dist, thr2)

