#
# Ben Tribelhorn
# 6-23-06
#

import os
import pickle

class Path:

	def __init__(self):
		self.x = []
		self.y = []
		self.thr = []
		
	def addPose(self, nx, ny, nthr):
		self.x.append(nx)
		self.y.append(ny)
		self.thr.append(nthr)
		
	def getLastPose(self):
		i = len(self.x)-1
		return self.x[i], self.y[i], self.thr[i]
		
class roombaHistory:
	"""
	roombaHistory is a data structure designed to store all relevant history for a roomba.
	"""

	def __init__(self):
		self.path = Path()
		self.lastPoint = []
		self.collisions = []
		self.times = []
		self.sensors = []
		self.index = -1
		
	def addPose(self, nx, ny, nthr, ntime, ncolls, nsensors):
		self.path.addPose(nx, ny, nthr)
		self.lastPoint = nx, ny, nthr
		self.collisions.append(ncolls)
		self.times.append(ntime)
		self.sensors.append(nsensors)
		
	def getNewPoint(self):
		return self.lastPoint[0:2]
		
	def readFromFile(self, filename):
		unpicklefile = open(filename, 'r')
		data = pickle.load(unpicklefile)
		unpicklefile.close()
		try:
			length = int(data[0])
			self.path = Path()
			self.lastPoint = []
			self.collisions = []
			self.times = []
			self.sensors = []
			for i in range(length):
				self.addPose(data[1][i], data[2][i], data[3][i], data[5][i], data[4][i], data[6][i])
		except:
			pass
	
	def writeToFile(self, filename):
		file = open(filename, 'w')
		data = [len(self.path.x), self.path.x, self.path.y, self.path.thr, self.collisions, self.times, self.sensors]
		pickle.dump(data, file)
		file.close()
		
	def getNextTimeStep(self):
		self.index += 1
		return self.path.x[self.index], self.path.y[self.index]
		
	def getDataNextTimeStep(self):
		return self.collisions[self.index], [self.path.x[self.index], self.path.y[self.index], self.path.thr[self.index]], self.sensors[self.index]





